/***********************************************************
 * $Id$
 *
 * FancyQT6
 *
 * Copyright (C) 2009-2011 ev-i GmbH & IBCL e.U.
 * Copyright (C) 2011-2013 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#include "fancyqt6.h"

#include <fancylog.h>

#ifndef FANCYQT6LOG_H_
#define FANCYQT6LOG_H_

// facility masks:
// facility "fancyqt6base"
#define  FANCYQT6_LOG_BASE     (1<<0)
// facility "fancyqt6remoting"
#define  FANCYQT6_LOG_REMOTING (1<<1)

namespace Fancy {

namespace Qt6 {

extern FANCYQT6_API fancylog_service *log_service;

// parse for logging cmdline args and filter out recognized options.
void FANCYQT6_API fancylog_parse_arg (int *argc, char **argv);

inline void vfancylog (int facility,
                       int priority, const char *fmt, va_list ap)
{
    va_list aq;
    va_copy(aq,ap);
    ::vfancylog(log_service,facility,priority,fmt,aq);
    va_end(aq);
}

#ifdef __GNUG__
inline void fancylog (int facility,
                      int priority, const char *fmt, ...)
__attribute__((format(printf,3,4)));

#endif

inline void fancylog (int facility,
                      int priority, const char *fmt, ...)
{
    va_list ap;
    va_start(ap, fmt);
    vfancylog(facility,priority,fmt,ap);
    va_end(ap);
}

}} // end namespaces

#endif /* FANCYQT6LOG_H_ */
